'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var classnames = require('classnames');
var icon = require('@highlight-ui/icon');
var typography = require('@highlight-ui/typography');
var utilsCommons = require('@highlight-ui/utils-commons');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles$1 = {
  "link": "Link-module__czQ1jvyT__v3-0-11",
  "icon": "Link-module__R8mgGdmf__v3-0-11",
  "inline": "Link-module__7TamO5Jt__v3-0-11"
};
var checkIfInternal = function (url) {
  return !/^https?:\/\/[^/?#]+/i.test(url) || url.indexOf(window.location.hostname) > -1;
};
var Link = React__default["default"].forwardRef(function (_a, ref) {
  var _b;
  var children = _a.children,
    className = _a.className,
    href = _a.href,
    metadata = _a.metadata,
    target = _a.target,
    _c = _a.variant,
    variant = _c === void 0 ? 'standalone' : _c,
    rel = _a.rel,
    restProps = __rest(_a, ["children", "className", "href", "metadata", "target", "variant", "rel"]);
  var isInternal = checkIfInternal(href || '');
  var inlineVariant = variant === 'inline';
  var appliedTarget = target || (isInternal ? undefined : '_blank');
  var appliedRel = rel || (isInternal ? undefined : 'noopener noreferrer');
  var showIcon = !inlineVariant && !isInternal;
  return React__default["default"].createElement("a", __assign({}, restProps, {
    className: classnames__default["default"](styles$1.link, (_b = {}, _b[styles$1.inline] = inlineVariant, _b), className),
    href: href,
    ref: ref,
    rel: appliedRel,
    target: appliedTarget
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement(typography.Body, {
    variant: !inlineVariant ? 'strong-base' : 'base',
    as: "span"
  }, children, showIcon && React__default["default"].createElement(icon.Icon, {
    name: "external-link",
    type: "solid",
    size: 12,
    className: styles$1.icon,
    metadata: utilsCommons.suffixMetadata(metadata, 'icon')
  })));
});
var styles = {
  "link": "DeprecatedLink-module__mMtSnFqi__v3-0-11",
  "iconContainer": "DeprecatedLink-module__7Sr-WYa1__v3-0-11",
  "disabledUnderline": "DeprecatedLink-module__sG8-VPfM__v3-0-11"
};

/**
 * @deprecated This component is deprecated and will be removed in future releases.
 * Please use `Link` component instead.
 */
var DeprecatedLink = React__default["default"].forwardRef(function (_a, ref) {
  var _b;
  var children = _a.children,
    className = _a.className,
    href = _a.href,
    metadata = _a.metadata,
    _c = _a.showIcon,
    showIcon = _c === void 0 ? false : _c,
    _d = _a.underline,
    underline = _d === void 0 ? true : _d,
    target = _a.target,
    restProps = __rest(_a, ["children", "className", "href", "metadata", "showIcon", "underline", "target"]);
  var rel = target === '_blank' ? 'noopener noreferrer' : '';
  return React__default["default"].createElement(typography.Typography, __assign({
    token: "text-link-default",
    component: "a",
    metadata: metadata
  }, restProps, {
    className: classnames__default["default"](className, styles.link, (_b = {}, _b[styles.disabledUnderline] = !underline, _b)),
    // @ts-ignore
    href: href,
    ref: ref,
    rel: rel,
    target: target
  }), children, ' ', showIcon && React__default["default"].createElement("span", {
    className: styles.iconContainer
  }, React__default["default"].createElement(icon.Icon, {
    name: "external-link",
    type: "solid",
    size: 12,
    metadata: utilsCommons.suffixMetadata(metadata, 'icon')
  })));
});
exports.DeprecatedLink = DeprecatedLink;
exports.Link = Link;
//# sourceMappingURL=index.js.map
